#include "toto.h"
#include "tabsort.h"

#if defined(VISUAL)
#define EXTERN_FUNC_VOID extern "C" _declspec(dllexport) void 
#define EXTERN_FUNC_PTREE extern "C" _declspec(dllexport) PPTREE 
#elif defined(BORLAND)
#define EXTERN_FUNC_VOID void __declspec(dllexport)  
#define EXTERN_FUNC_PTREE PPTREE __declspec(dllexport)  
#else 
#define EXTERN_FUNC_VOID extern "C" void    
#define EXTERN_FUNC_PTREE extern "C" PPTREE    
#endif

extern void                 (*ptMetaExit)(int, const char *) ;
extern TabSortString        (*ptStackString)[];
extern TabSortEqual<TREE>   (*ptStackPtree)[];
extern bool                 *ptStackInitialized ;
extern int                  *ptTabPtPos ;
extern PPTREE               *ptTabPt ;

EXTERN_FUNC_VOID totoSetParam ( char *metaName
    , TabSortString **pptStackString, TabSortEqual<TREE> **pptStackPtree
    , bool *pptStackInitialized, void(*ptparaMetaExit)(int, const char *)
    , int *ptTabPtPosParam, PPTREE *ptTabPtParam )
{
    MetaInit(metaName);
    ptStackString = (TabSortString(*)[])pptStackString ;
    ptStackPtree = (TabSortEqual<TREE> (*)[])pptStackPtree ;
    ptStackInitialized = pptStackInitialized ;
    ptMetaExit = ptparaMetaExit ;
    ptTabPtPos = ptTabPtPosParam ;
    ptTabPt = ptTabPtParam ;
}

static PTREE        treeKeeper ;
static Grammtoto    *ptGrammar = 0 ;

EXTERN_FUNC_PTREE totoRootDecode ( EString &ruleName, EString &val
    , CoordString &coord, bool checkTag )
{
    if ( !ptGrammar ) {
        ptGrammar = new Grammtoto ;
    }
    treeKeeper = ptGrammar -> DecodeString(ruleName, val, coord, checkTag);
    return (PPTREE)treeKeeper ;
}

EXTERN_FUNC_VOID totoRootEncode ( EString &ruleName, EString &resString
    , PTREE val )
{
    if ( !ptGrammar ) {
        ptGrammar = new Grammtoto ;
    }
    ptGrammar -> EncodeString(ruleName, resString, val);
}

PTREE Grammtoto::DecodeObjectIdentifier ( PTREE objectList )
{
    int     number ;
    PTREE   elem ;
    PTREE   lastList ;
    PTREE   retList ;
    
    number = atoi(Value(lastList = objectList));
    objectList.Nextl();
    switch ( number ) {
    }
    while ( lastList != PTREE(0) ) {
        elem = PTREE(Value(lastList));
        retList = AddList(retList, elem);
        lastList.Nextl();
    }
    
    PTREE   objList ;
    
    objList = PTREE(asn::OBJECT_IDENTIFIER_VALUE, 1);
    objList.ReplaceTree(1, retList);
    return objList ;
}

PTREE Grammtoto::Root ( EString &val, CoordString &coord, bool checkTag )
{
    int         codedLength = coord.length ;
    int         codedPos = coord.pos ;
    PTREE       __resCoding ;
    CoordString codedCoord(coord.pos, coord.length);
    char        __tempo ;
    char        __firstChar = (char)((val [coord.pos])&~0x20 & 0xff);
    
    switch ( __firstChar ) {
        case '\200' : 
            {
                if ( !TakeTagged(val, 1, coord, codedCoord) ) 
                    return PTREE(0);
                {
                    checkTag = true ;
                    __resCoding = __Rule0(val, codedCoord, checkTag);
                    return CreateNamedNode("declaration-testeur"
                        , __resCoding);
                }
            }
        case '\201' : 
            {
                if ( !TakeTagged(val, 1, coord, codedCoord) ) 
                    return PTREE(0);
                {
                    checkTag = true ;
                    __resCoding = __Rule1(val, codedCoord, checkTag);
                    return CreateNamedNode("declaration-pco", __resCoding);
                }
            }
        case '\202' : 
            {
                if ( !TakeTagged(val, 1, coord, codedCoord) ) 
                    return PTREE(0);
                {
                    checkTag = true ;
                    __resCoding = __Rule2(val, codedCoord, checkTag);
                    return CreateNamedNode("test-pco", __resCoding);
                }
            }
        case '\203' : 
            {
                if ( !TakeTagged(val, 1, coord, codedCoord) ) 
                    return PTREE(0);
                {
                    checkTag = true ;
                    __resCoding = __Rule3(val, codedCoord, checkTag);
                    return CreateNamedNode("envoie-evenement", __resCoding);
                }
            }
        case '\204' : 
            {
                if ( !TakeTagged(val, 1, coord, codedCoord) ) 
                    return PTREE(0);
                {
                    checkTag = true ;
                    __resCoding = __Rule4(val, codedCoord, checkTag);
                    return CreateNamedNode("reception-evenement"
                        , __resCoding);
                }
            }
        case '\205' : 
            {
                if ( !TakeTagged(val, 1, coord, codedCoord) ) 
                    return PTREE(0);
                {
                    checkTag = true ;
                    __resCoding = __Rule5(val, codedCoord, checkTag);
                    return CreateNamedNode("reception-evenement-bloque"
                        , __resCoding);
                }
            }
        case '\206' : 
            {
                if ( !TakeTagged(val, 1, coord, codedCoord) ) 
                    return PTREE(0);
                {
                    checkTag = true ;
                    __resCoding = __Rule6(val, codedCoord, checkTag);
                    return CreateNamedNode("envoie-evenement-chunk"
                        , __resCoding);
                }
            }
        case '\207' : 
            {
                if ( !TakeTagged(val, 1, coord, codedCoord) ) 
                    return PTREE(0);
                {
                    checkTag = true ;
                    __resCoding = __Rule7(val, codedCoord, checkTag);
                    return CreateNamedNode("envoie-evenement-chunk-end"
                        , __resCoding);
                }
            }
        case '\210' : 
            {
                if ( !TakeTagged(val, 1, coord, codedCoord) ) 
                    return PTREE(0);
                {
                    checkTag = true ;
                    __resCoding = __Rule8(val, codedCoord, checkTag);
                    return CreateNamedNode("close-pco", __resCoding);
                }
            }
        case '\211' : 
            {
                if ( !TakeTagged(val, 1, coord, codedCoord) ) 
                    return PTREE(0);
                {
                    checkTag = true ;
                    __resCoding = __Rule9(val, codedCoord, checkTag);
                    return CreateNamedNode("number-connect", __resCoding);
                }
            }
        case '\212' : 
            {
                if ( !TakeTagged(val, 1, coord, codedCoord) ) 
                    return PTREE(0);
                {
                    checkTag = true ;
                    if ( 1 ) {
                        int __startPos ;
                        __startPos = codedCoord.length ;
                        __resCoding
                            = GetIA5String(val, codedCoord, checkTag);
                        if ( checkTag ) {
                            __startPos = __startPos - codedCoord.length ;
                            coord.pos += __startPos ;
                            coord.length -= __startPos ;
                        }
                    } else 
                        ;
                    return CreateNamedNode("kill", __resCoding);
                }
            }
        case '\213' : 
            {
                if ( !TakeTagged(val, 1, coord, codedCoord) ) 
                    return PTREE(0);
                {
                    checkTag = true ;
                    if ( 1 ) {
                        int __startPos ;
                        __startPos = codedCoord.length ;
                        __resCoding
                            = GetIA5String(val, codedCoord, checkTag);
                        if ( checkTag ) {
                            __startPos = __startPos - codedCoord.length ;
                            coord.pos += __startPos ;
                            coord.length -= __startPos ;
                        }
                    } else 
                        ;
                    return CreateNamedNode("kill-bus", __resCoding);
                }
            }
        case '\215' : 
            {
                if ( !TakeTagged(val, 1, coord, codedCoord) ) 
                    return PTREE(0);
                {
                    checkTag = true ;
                    if ( 1 ) {
                        int __startPos ;
                        __startPos = codedCoord.length ;
                        __resCoding
                            = GetIA5String(val, codedCoord, checkTag);
                        if ( checkTag ) {
                            __startPos = __startPos - codedCoord.length ;
                            coord.pos += __startPos ;
                            coord.length -= __startPos ;
                        }
                    } else 
                        ;
                    return CreateNamedNode("kill-old", __resCoding);
                }
            }
        case '\214' : 
            {
                if ( !TakeTagged(val, 1, coord, codedCoord) ) 
                    return PTREE(0);
                {
                    checkTag = true ;
                    __resCoding = __Rule10(val, codedCoord, checkTag);
                    return CreateNamedNode("enumerate", __resCoding);
                }
            }
        default : 
            {
                if ( CompareTag("\237\207\150", val
                        , CoordString(coord.pos, 3)) ) {
                    if ( !TakeTagged(val, 3, coord, codedCoord) ) 
                        return PTREE(0);
                    {
                        checkTag = true ;
                        if ( true ) {
                            int __startPos ;
                            __startPos = codedCoord.length ;
                            __resCoding
                                = GetNullType(val, codedCoord, checkTag);
                            if ( checkTag ) {
                                __startPos = __startPos - codedCoord.length ;
                                coord.pos += __startPos ;
                                coord.length -= __startPos ;
                            }
                        } else 
                            ;
                        return CreateNamedNode("acknowledgement"
                            , __resCoding);
                    }
                } else if ( CompareTag("\237\207\152", val
                            , CoordString(coord.pos, 3)) ) {
                    if ( !TakeTagged(val, 3, coord, codedCoord) ) 
                        return PTREE(0);
                    {
                        checkTag = true ;
                        if ( 1 ) {
                            int __startPos ;
                            __startPos = codedCoord.length ;
                            __resCoding
                                = GetIA5String(val, codedCoord, checkTag);
                            if ( checkTag ) {
                                __startPos = __startPos - codedCoord.length ;
                                coord.pos += __startPos ;
                                coord.length -= __startPos ;
                            }
                        } else 
                            ;
                        return CreateNamedNode("named-acknowledgement"
                            , __resCoding);
                    }
                } else if ( CompareTag("\237\207\151", val
                            , CoordString(coord.pos, 3)) ) {
                    if ( !TakeTagged(val, 3, coord, codedCoord) ) 
                        return PTREE(0);
                    {
                        checkTag = true ;
                        if ( true ) {
                            int __startPos ;
                            __startPos = codedCoord.length ;
                            __resCoding
                                = GetNullType(val, codedCoord, checkTag);
                            if ( checkTag ) {
                                __startPos = __startPos - codedCoord.length ;
                                coord.pos += __startPos ;
                                coord.length -= __startPos ;
                            }
                        } else 
                            ;
                        return CreateNamedNode("pas-evenement", __resCoding);
                    }
                } else if ( CompareTag("\237\207\153", val
                            , CoordString(coord.pos, 3)) ) {
                    if ( !TakeTagged(val, 3, coord, codedCoord) ) 
                        return PTREE(0);
                    {
                        checkTag = true ;
                        if ( 1 ) {
                            int __startPos ;
                            __startPos = codedCoord.length ;
                            __resCoding
                                = GetIA5String(val, codedCoord, checkTag);
                            if ( checkTag ) {
                                __startPos = __startPos - codedCoord.length ;
                                coord.pos += __startPos ;
                                coord.length -= __startPos ;
                            }
                        } else 
                            ;
                        return CreateNamedNode("version", __resCoding);
                    }
                }
            }
    }
    return __resCoding ;
}

void Grammtoto::Root ( EString &resString, PTREE val )
{
    EString __valString ;
    char    *__compString = Value(val);
    int     __compVal ;
    
    __compVal = strcmp(__compString, "kill");
    if ( __compVal == 0 ) {
        if ( val.TreeArity() >= 2 ) 
            val = val [2];
        EncodeIA5String(__valString, val);
        PutTag(__valString, "\212", false);
        resString += __valString ;
    } else if ( __compVal < 0 ) {
        __compVal = strcmp(__compString, "declaration-testeur");
        if ( __compVal == 0 ) {
            if ( val.TreeArity() >= 2 ) 
                val = val [2];
            __Rule0(__valString, val);
            PutTag(__valString, "\200", false);
            resString += __valString ;
        } else if ( __compVal < 0 ) {
            __compVal = strcmp(__compString, "close-pco");
            if ( __compVal == 0 ) {
                if ( val.TreeArity() >= 2 ) 
                    val = val [2];
                __Rule8(__valString, val);
                PutTag(__valString, "\210", false);
                resString += __valString ;
            } else if ( __compVal < 0 ) {
                __compVal = strcmp(__compString, "acknowledgement");
                if ( __compVal == 0 ) {
                    if ( val.TreeArity() >= 2 ) 
                        val = val [2];
                    EncodeNullType(__valString);
                    PutTag(__valString, "\237\207\150", false);
                    resString += __valString ;
                }
            } else {
                __compVal = strcmp(__compString, "declaration-pco");
                if ( __compVal == 0 ) {
                    if ( val.TreeArity() >= 2 ) 
                        val = val [2];
                    __Rule1(__valString, val);
                    PutTag(__valString, "\201", false);
                    resString += __valString ;
                }
            }
        } else {
            __compVal = strcmp(__compString, "envoie-evenement");
            if ( __compVal == 0 ) {
                if ( val.TreeArity() >= 2 ) 
                    val = val [2];
                __Rule3(__valString, val);
                PutTag(__valString, "\203", false);
                resString += __valString ;
            } else if ( __compVal < 0 ) {
                __compVal = strcmp(__compString, "enumerate");
                if ( __compVal == 0 ) {
                    if ( val.TreeArity() >= 2 ) 
                        val = val [2];
                    __Rule10(__valString, val);
                    PutTag(__valString, "\214", false);
                    resString += __valString ;
                }
            } else {
                __compVal = strcmp(__compString, "envoie-evenement-chunk");
                if ( __compVal == 0 ) {
                    if ( val.TreeArity() >= 2 ) 
                        val = val [2];
                    __Rule6(__valString, val);
                    PutTag(__valString, "\206", false);
                    resString += __valString ;
                } else {
                    __compVal
                        = strcmp(__compString
                            , "envoie-evenement-chunk-end");
                    if ( __compVal == 0 ) {
                        if ( val.TreeArity() >= 2 ) 
                            val = val [2];
                        __Rule7(__valString, val);
                        PutTag(__valString, "\207", false);
                        resString += __valString ;
                    }
                }
            }
        }
    } else {
        __compVal = strcmp(__compString, "pas-evenement");
        if ( __compVal == 0 ) {
            if ( val.TreeArity() >= 2 ) 
                val = val [2];
            EncodeNullType(__valString);
            PutTag(__valString, "\237\207\151", false);
            resString += __valString ;
        } else if ( __compVal < 0 ) {
            __compVal = strcmp(__compString, "kill-old");
            if ( __compVal == 0 ) {
                if ( val.TreeArity() >= 2 ) 
                    val = val [2];
                EncodeIA5String(__valString, val);
                PutTag(__valString, "\215", false);
                resString += __valString ;
            } else if ( __compVal < 0 ) {
                __compVal = strcmp(__compString, "kill-bus");
                if ( __compVal == 0 ) {
                    if ( val.TreeArity() >= 2 ) 
                        val = val [2];
                    EncodeIA5String(__valString, val);
                    PutTag(__valString, "\213", false);
                    resString += __valString ;
                }
            } else {
                __compVal = strcmp(__compString, "named-acknowledgement");
                if ( __compVal == 0 ) {
                    if ( val.TreeArity() >= 2 ) 
                        val = val [2];
                    EncodeIA5String(__valString, val);
                    PutTag(__valString, "\237\207\152", false);
                    resString += __valString ;
                } else {
                    __compVal = strcmp(__compString, "number-connect");
                    if ( __compVal == 0 ) {
                        if ( val.TreeArity() >= 2 ) 
                            val = val [2];
                        __Rule9(__valString, val);
                        PutTag(__valString, "\211", false);
                        resString += __valString ;
                    }
                }
            }
        } else {
            __compVal = strcmp(__compString, "reception-evenement-bloque");
            if ( __compVal == 0 ) {
                if ( val.TreeArity() >= 2 ) 
                    val = val [2];
                __Rule5(__valString, val);
                PutTag(__valString, "\205", false);
                resString += __valString ;
            } else if ( __compVal < 0 ) {
                __compVal = strcmp(__compString, "reception-evenement");
                if ( __compVal == 0 ) {
                    if ( val.TreeArity() >= 2 ) 
                        val = val [2];
                    __Rule4(__valString, val);
                    PutTag(__valString, "\204", false);
                    resString += __valString ;
                }
            } else {
                __compVal = strcmp(__compString, "test-pco");
                if ( __compVal == 0 ) {
                    if ( val.TreeArity() >= 2 ) 
                        val = val [2];
                    __Rule2(__valString, val);
                    PutTag(__valString, "\202", false);
                    resString += __valString ;
                } else {
                    __compVal = strcmp(__compString, "version");
                    if ( __compVal == 0 ) {
                        if ( val.TreeArity() >= 2 ) 
                            val = val [2];
                        EncodeIA5String(__valString, val);
                        PutTag(__valString, "\237\207\153", false);
                        resString += __valString ;
                    }
                }
            }
        }
    }
}

PTREE Grammtoto::__Rule0 ( EString &val, CoordString &coord, bool checkTag )
{
    int         codedLength = coord.length ;
    int         codedPos = coord.pos ;
    PTREE       __resCoding ;
    CoordString codedCoord(coord.pos, coord.length);
    char        __tempo ;
    CoordString embeddedCodedCoord(coord.pos, coord.length);
    
    if ( checkTag ) {
        if ( (__tempo = (char)((val [coord.pos])&~0x20 & 0xff))
                && __tempo == '\020' ) {
            if ( !TakeTagged(val, 1, coord, codedCoord) ) 
                return PTREE(0);
        } else 
            return PTREE(0);
    }
    checkTag = true ;
    
    bool    __analyze = false ;
    PTREE   __listSequence ;
    PTREE   __listSequencef ;
    
    if ( codedCoord.length > 0 ) {
        if ( (__tempo = (char)((val [codedCoord.pos])&~0x20 & 0xff))
                && __tempo == '\026' ) {
            if ( !TakeTagged(val, 1, codedCoord, embeddedCodedCoord) ) 
                return PTREE(0);
            __resCoding = GetIA5String(val, embeddedCodedCoord, false);
            PTREE   __headTree = CreateNamedNode("name", __resCoding);
            __listSequencef
                = AddToList(__listSequence, __headTree, __listSequencef);
        } else {
            codedCoord.length = 0 ;
        }
    }
    if ( codedCoord.length > 0 ) {
        if ( (__tempo = (char)((val [codedCoord.pos])&~0x20 & 0xff))
                && __tempo == '\026' ) {
            if ( !TakeTagged(val, 1, codedCoord, embeddedCodedCoord) ) 
                return PTREE(0);
            __resCoding = GetIA5String(val, embeddedCodedCoord, false);
            PTREE   __headTree = CreateNamedNode("ip-address", __resCoding);
            __listSequencef
                = AddToList(__listSequence, __headTree, __listSequencef);
        } else {
            codedCoord.length = 0 ;
        }
    }
    if ( codedCoord.length > 0 ) {
        if ( (__tempo = (char)((val [codedCoord.pos])&~0x20 & 0xff))
                && __tempo == '\002' ) {
            if ( !TakeTagged(val, 1, codedCoord, embeddedCodedCoord) ) 
                return PTREE(0);
            __resCoding = GetInteger(val, embeddedCodedCoord, false);
            PTREE   __headTree = CreateNamedNode("address", __resCoding);
            __listSequencef
                = AddToList(__listSequence, __headTree, __listSequencef);
        } else {
            codedCoord.length = 0 ;
        }
    }
    if ( codedCoord.length > 0 ) {
        if ( true ) {
            checkTag = true ;
            __resCoding = __Rule11(val, codedCoord, checkTag);
            PTREE   __headTree = CreateNamedNode("essai", __resCoding);
            __listSequencef
                = AddToList(__listSequence, __headTree, __listSequencef);
        } else {
            codedCoord.length = 0 ;
        }
    }
    if ( codedCoord.length > 0 ) {
        if ( (__tempo = (char)((val [codedCoord.pos])&~0x20 & 0xff))
                && __tempo == '\001' ) {
            if ( !TakeTagged(val, 1, codedCoord, embeddedCodedCoord) ) 
                return PTREE(0);
            __resCoding = GetBoolean(val, embeddedCodedCoord, false);
            PTREE   __headTree = CreateNamedNode("ack", __resCoding);
            __listSequencef
                = AddToList(__listSequence, __headTree, __listSequencef);
        } else {
        }
    }
    
    PTREE   __retValue = PTREE(asn::SEQUENCE_VALUE, 1);
    
    __retValue.ReplaceTree(1, __listSequence);
    __resCoding = __retValue ;
    return __resCoding ;
}

void Grammtoto::__Rule0 ( EString &resString, PTREE val )
{
    EString __valString ;
    
    {
        EString __sequenceString ;
        if ( val.TreeArity() >= 1 ) 
            val = val [1];
        if ( !strcmp(Value(val), "name") ) {
            PutSonNext  __putSonNext(&val, true);
            __valString = "";
            EncodeIA5String(__valString, val);
            __sequenceString += __valString ;
        } else {
            val = PTREE(0);
        }
        if ( !strcmp(Value(val), "ip-address") ) {
            PutSonNext  __putSonNext(&val, true);
            __valString = "";
            EncodeIA5String(__valString, val);
            __sequenceString += __valString ;
        } else {
            val = PTREE(0);
        }
        if ( !strcmp(Value(val), "address") ) {
            PutSonNext  __putSonNext(&val, true);
            __valString = "";
            {
                ENCODE_INT  __val = CONVERT_TO_INT(Value(val));
                if ( NumberTree(val) == asn::UN_MINUS ) {
                    __val = -1 * __val ;
                }
                EncodeInteger(__valString, __val);
            }
            __sequenceString += __valString ;
        } else {
            val = PTREE(0);
        }
        if ( !strcmp(Value(val), "essai") ) {
            PutSonNext  __putSonNext(&val, true);
            __valString = "";
            __Rule11(__valString, val);
            __sequenceString += __valString ;
        } else {
            val = PTREE(0);
        }
        if ( !strcmp(Value(val), "ack") ) {
            PutSonNext  __putSonNext(&val, true);
            __valString = "";
            bool    __val = false ;
            if ( NumberTree(val) == asn::TRUE ) {
                __val = true ;
            }
            EncodeBoolean(__valString, __val);
            __sequenceString += __valString ;
        } else {
        }
        PutTag(__sequenceString, "\060", false);
        resString += __sequenceString ;
    }
}

PTREE Grammtoto::__Rule1 ( EString &val, CoordString &coord, bool checkTag )
{
    int         codedLength = coord.length ;
    int         codedPos = coord.pos ;
    PTREE       __resCoding ;
    CoordString codedCoord(coord.pos, coord.length);
    char        __tempo ;
    CoordString embeddedCodedCoord(coord.pos, coord.length);
    
    if ( checkTag ) {
        if ( (__tempo = (char)((val [coord.pos])&~0x20 & 0xff))
                && __tempo == '\020' ) {
            if ( !TakeTagged(val, 1, coord, codedCoord) ) 
                return PTREE(0);
        } else 
            return PTREE(0);
    }
    checkTag = true ;
    
    bool    __analyze = false ;
    PTREE   __listSequence ;
    PTREE   __listSequencef ;
    
    if ( codedCoord.length > 0 ) {
        if ( (__tempo = (char)((val [codedCoord.pos])&~0x20 & 0xff))
                && __tempo == '\026' ) {
            if ( !TakeTagged(val, 1, codedCoord, embeddedCodedCoord) ) 
                return PTREE(0);
            __resCoding = GetIA5String(val, embeddedCodedCoord, false);
            PTREE   __headTree = CreateNamedNode("name", __resCoding);
            __listSequencef
                = AddToList(__listSequence, __headTree, __listSequencef);
        } else {
            codedCoord.length = 0 ;
        }
    }
    if ( codedCoord.length > 0 ) {
        if ( (__tempo = (char)((val [codedCoord.pos])&~0x20 & 0xff))
                && __tempo == '\026' ) {
            if ( !TakeTagged(val, 1, codedCoord, embeddedCodedCoord) ) 
                return PTREE(0);
            __resCoding = GetIA5String(val, embeddedCodedCoord, false);
            PTREE   __headTree = CreateNamedNode("pco", __resCoding);
            __listSequencef
                = AddToList(__listSequence, __headTree, __listSequencef);
        } else {
            codedCoord.length = 0 ;
        }
    }
    if ( codedCoord.length > 0 ) {
        if ( (__tempo = (char)((val [codedCoord.pos])&~0x20 & 0xff))
                && __tempo == '\001' ) {
            if ( !TakeTagged(val, 1, codedCoord, embeddedCodedCoord) ) 
                return PTREE(0);
            __resCoding = GetBoolean(val, embeddedCodedCoord, false);
            PTREE   __headTree
                = CreateNamedNode("output-only", __resCoding);
            __listSequencef
                = AddToList(__listSequence, __headTree, __listSequencef);
        } else {
        }
    }
    
    PTREE   __retValue = PTREE(asn::SEQUENCE_VALUE, 1);
    
    __retValue.ReplaceTree(1, __listSequence);
    __resCoding = __retValue ;
    return __resCoding ;
}

void Grammtoto::__Rule1 ( EString &resString, PTREE val )
{
    EString __valString ;
    
    {
        EString __sequenceString ;
        if ( val.TreeArity() >= 1 ) 
            val = val [1];
        if ( !strcmp(Value(val), "name") ) {
            PutSonNext  __putSonNext(&val, true);
            __valString = "";
            EncodeIA5String(__valString, val);
            __sequenceString += __valString ;
        } else {
            val = PTREE(0);
        }
        if ( !strcmp(Value(val), "pco") ) {
            PutSonNext  __putSonNext(&val, true);
            __valString = "";
            EncodeIA5String(__valString, val);
            __sequenceString += __valString ;
        } else {
            val = PTREE(0);
        }
        if ( !strcmp(Value(val), "output-only") ) {
            PutSonNext  __putSonNext(&val, true);
            __valString = "";
            bool    __val = false ;
            if ( NumberTree(val) == asn::TRUE ) {
                __val = true ;
            }
            EncodeBoolean(__valString, __val);
            __sequenceString += __valString ;
        } else {
        }
        PutTag(__sequenceString, "\060", false);
        resString += __sequenceString ;
    }
}

PTREE Grammtoto::__Rule2 ( EString &val, CoordString &coord, bool checkTag )
{
    int         codedLength = coord.length ;
    int         codedPos = coord.pos ;
    PTREE       __resCoding ;
    CoordString codedCoord(coord.pos, coord.length);
    char        __tempo ;
    CoordString embeddedCodedCoord(coord.pos, coord.length);
    
    if ( checkTag ) {
        if ( (__tempo = (char)((val [coord.pos])&~0x20 & 0xff))
                && __tempo == '\020' ) {
            if ( !TakeTagged(val, 1, coord, codedCoord) ) 
                return PTREE(0);
        } else 
            return PTREE(0);
    }
    checkTag = true ;
    
    bool    __analyze = false ;
    PTREE   __listSequence ;
    PTREE   __listSequencef ;
    
    if ( codedCoord.length > 0 ) {
        if ( (__tempo = (char)((val [codedCoord.pos])&~0x20 & 0xff))
                && __tempo == '\026' ) {
            if ( !TakeTagged(val, 1, codedCoord, embeddedCodedCoord) ) 
                return PTREE(0);
            __resCoding = GetIA5String(val, embeddedCodedCoord, false);
            PTREE   __headTree = CreateNamedNode("name", __resCoding);
            __listSequencef
                = AddToList(__listSequence, __headTree, __listSequencef);
        } else {
            codedCoord.length = 0 ;
        }
    }
    if ( codedCoord.length > 0 ) {
        if ( (__tempo = (char)((val [codedCoord.pos])&~0x20 & 0xff))
                && __tempo == '\026' ) {
            if ( !TakeTagged(val, 1, codedCoord, embeddedCodedCoord) ) 
                return PTREE(0);
            __resCoding = GetIA5String(val, embeddedCodedCoord, false);
            PTREE   __headTree = CreateNamedNode("pco", __resCoding);
            __listSequencef
                = AddToList(__listSequence, __headTree, __listSequencef);
        } else {
            codedCoord.length = 0 ;
        }
    }
    if ( codedCoord.length > 0 ) {
        if ( (__tempo = (char)((val [codedCoord.pos])&~0x20 & 0xff))
                && __tempo == '\001' ) {
            if ( !TakeTagged(val, 1, codedCoord, embeddedCodedCoord) ) 
                return PTREE(0);
            __resCoding = GetBoolean(val, embeddedCodedCoord, false);
            PTREE   __headTree = CreateNamedNode("state", __resCoding);
            __listSequencef
                = AddToList(__listSequence, __headTree, __listSequencef);
        } else {
        }
    }
    if ( codedCoord.length > 0 ) {
        if ( (__tempo = (char)((val [codedCoord.pos])&~0x20 & 0xff))
                && __tempo == '\002' ) {
            if ( !TakeTagged(val, 1, codedCoord, embeddedCodedCoord) ) 
                return PTREE(0);
            __resCoding = GetInteger(val, embeddedCodedCoord, false);
            PTREE   __headTree
                = CreateNamedNode("size-packet", __resCoding);
            __listSequencef
                = AddToList(__listSequence, __headTree, __listSequencef);
        } else {
        }
    }
    
    PTREE   __retValue = PTREE(asn::SEQUENCE_VALUE, 1);
    
    __retValue.ReplaceTree(1, __listSequence);
    __resCoding = __retValue ;
    return __resCoding ;
}

void Grammtoto::__Rule2 ( EString &resString, PTREE val )
{
    EString __valString ;
    
    {
        EString __sequenceString ;
        if ( val.TreeArity() >= 1 ) 
            val = val [1];
        if ( !strcmp(Value(val), "name") ) {
            PutSonNext  __putSonNext(&val, true);
            __valString = "";
            EncodeIA5String(__valString, val);
            __sequenceString += __valString ;
        } else {
            val = PTREE(0);
        }
        if ( !strcmp(Value(val), "pco") ) {
            PutSonNext  __putSonNext(&val, true);
            __valString = "";
            EncodeIA5String(__valString, val);
            __sequenceString += __valString ;
        } else {
            val = PTREE(0);
        }
        if ( !strcmp(Value(val), "state") ) {
            PutSonNext  __putSonNext(&val, true);
            __valString = "";
            bool    __val = false ;
            if ( NumberTree(val) == asn::TRUE ) {
                __val = true ;
            }
            EncodeBoolean(__valString, __val);
            __sequenceString += __valString ;
        } else {
        }
        if ( !strcmp(Value(val), "size-packet") ) {
            PutSonNext  __putSonNext(&val, true);
            __valString = "";
            {
                ENCODE_INT  __val = CONVERT_TO_INT(Value(val));
                if ( NumberTree(val) == asn::UN_MINUS ) {
                    __val = -1 * __val ;
                }
                EncodeInteger(__valString, __val);
            }
            __sequenceString += __valString ;
        } else {
        }
        PutTag(__sequenceString, "\060", false);
        resString += __sequenceString ;
    }
}

PTREE Grammtoto::__Rule3 ( EString &val, CoordString &coord, bool checkTag )
{
    int         codedLength = coord.length ;
    int         codedPos = coord.pos ;
    PTREE       __resCoding ;
    CoordString codedCoord(coord.pos, coord.length);
    char        __tempo ;
    CoordString embeddedCodedCoord(coord.pos, coord.length);
    
    if ( checkTag ) {
        if ( (__tempo = (char)((val [coord.pos])&~0x20 & 0xff))
                && __tempo == '\020' ) {
            if ( !TakeTagged(val, 1, coord, codedCoord) ) 
                return PTREE(0);
        } else 
            return PTREE(0);
    }
    checkTag = true ;
    
    bool    __analyze = false ;
    PTREE   __listSequence ;
    PTREE   __listSequencef ;
    
    if ( codedCoord.length > 0 ) {
        if ( (__tempo = (char)((val [codedCoord.pos])&~0x20 & 0xff))
                && __tempo == '\026' ) {
            if ( !TakeTagged(val, 1, codedCoord, embeddedCodedCoord) ) 
                return PTREE(0);
            __resCoding = GetIA5String(val, embeddedCodedCoord, false);
            PTREE   __headTree = CreateNamedNode("name", __resCoding);
            __listSequencef
                = AddToList(__listSequence, __headTree, __listSequencef);
        } else {
            codedCoord.length = 0 ;
        }
    }
    if ( codedCoord.length > 0 ) {
        if ( (__tempo = (char)((val [codedCoord.pos])&~0x20 & 0xff))
                && __tempo == '\026' ) {
            if ( !TakeTagged(val, 1, codedCoord, embeddedCodedCoord) ) 
                return PTREE(0);
            __resCoding = GetIA5String(val, embeddedCodedCoord, false);
            PTREE   __headTree = CreateNamedNode("pco", __resCoding);
            __listSequencef
                = AddToList(__listSequence, __headTree, __listSequencef);
        } else {
            codedCoord.length = 0 ;
        }
    }
    if ( codedCoord.length > 0 ) {
        if ( (__tempo = (char)((val [codedCoord.pos])&~0x20 & 0xff))
                && __tempo == '\026' ) {
            if ( !TakeTagged(val, 1, codedCoord, embeddedCodedCoord) ) 
                return PTREE(0);
            __resCoding = GetIA5String(val, embeddedCodedCoord, false);
            PTREE   __headTree = CreateNamedNode("sender", __resCoding);
            __listSequencef
                = AddToList(__listSequence, __headTree, __listSequencef);
        } else {
        }
    }
    if ( codedCoord.length > 0 ) {
        if ( (__tempo = (char)((val [codedCoord.pos])&~0x20 & 0xff))
                && __tempo == '\004' ) {
            if ( !TakeTagged(val, 1, codedCoord, embeddedCodedCoord) ) 
                return PTREE(0);
            __resCoding = GetOctetString(val, embeddedCodedCoord, false);
            PTREE   __headTree = CreateNamedNode("content", __resCoding);
            __listSequencef
                = AddToList(__listSequence, __headTree, __listSequencef);
        } else {
            codedCoord.length = 0 ;
        }
    }
    if ( codedCoord.length > 0 ) {
        if ( (__tempo = (char)((val [codedCoord.pos])&~0x20 & 0xff))
                && __tempo == '\200' ) {
            if ( !TakeTagged(val, 1, codedCoord, embeddedCodedCoord) ) 
                return PTREE(0);
            checkTag = true ;
            if ( true ) {
                int __startPos ;
                __startPos = embeddedCodedCoord.length ;
                __resCoding = GetInteger(val, embeddedCodedCoord, checkTag);
                if ( checkTag ) {
                    __startPos = __startPos - embeddedCodedCoord.length ;
                    codedCoord.pos += __startPos ;
                    codedCoord.length -= __startPos ;
                }
            } else 
                ;
            PTREE   __headTree = CreateNamedNode("time", __resCoding);
            __listSequencef
                = AddToList(__listSequence, __headTree, __listSequencef);
        } else {
        }
    }
    if ( codedCoord.length > 0 ) {
        if ( (__tempo = (char)((val [codedCoord.pos])&~0x20 & 0xff))
                && __tempo == '\201' ) {
            if ( !TakeTagged(val, 1, codedCoord, embeddedCodedCoord) ) 
                return PTREE(0);
            checkTag = true ;
            if ( true ) {
                int __startPos ;
                __startPos = embeddedCodedCoord.length ;
                __resCoding = GetInteger(val, embeddedCodedCoord, checkTag);
                if ( checkTag ) {
                    __startPos = __startPos - embeddedCodedCoord.length ;
                    codedCoord.pos += __startPos ;
                    codedCoord.length -= __startPos ;
                }
            } else 
                ;
            PTREE   __headTree = CreateNamedNode("utime", __resCoding);
            __listSequencef
                = AddToList(__listSequence, __headTree, __listSequencef);
        } else {
        }
    }
    if ( codedCoord.length > 0 ) {
        if ( (__tempo = (char)((val [codedCoord.pos])&~0x20 & 0xff))
                && __tempo == '\202' ) {
            if ( !TakeTagged(val, 1, codedCoord, embeddedCodedCoord) ) 
                return PTREE(0);
            checkTag = true ;
            if ( true ) {
                int __startPos ;
                __startPos = embeddedCodedCoord.length ;
                __resCoding = GetInteger(val, embeddedCodedCoord, checkTag);
                if ( checkTag ) {
                    __startPos = __startPos - embeddedCodedCoord.length ;
                    codedCoord.pos += __startPos ;
                    codedCoord.length -= __startPos ;
                }
            } else 
                ;
            PTREE   __headTree = CreateNamedNode("ctime", __resCoding);
            __listSequencef
                = AddToList(__listSequence, __headTree, __listSequencef);
        } else {
        }
    }
    if ( codedCoord.length > 0 ) {
        if ( (__tempo = (char)((val [codedCoord.pos])&~0x20 & 0xff))
                && __tempo == '\203' ) {
            if ( !TakeTagged(val, 1, codedCoord, embeddedCodedCoord) ) 
                return PTREE(0);
            checkTag = true ;
            if ( true ) {
                int __startPos ;
                __startPos = embeddedCodedCoord.length ;
                __resCoding = GetInteger(val, embeddedCodedCoord, checkTag);
                if ( checkTag ) {
                    __startPos = __startPos - embeddedCodedCoord.length ;
                    codedCoord.pos += __startPos ;
                    codedCoord.length -= __startPos ;
                }
            } else 
                ;
            PTREE   __headTree = CreateNamedNode("cutime", __resCoding);
            __listSequencef
                = AddToList(__listSequence, __headTree, __listSequencef);
        } else {
        }
    }
    
    PTREE   __retValue = PTREE(asn::SEQUENCE_VALUE, 1);
    
    __retValue.ReplaceTree(1, __listSequence);
    __resCoding = __retValue ;
    return __resCoding ;
}

void Grammtoto::__Rule3 ( EString &resString, PTREE val )
{
    EString __valString ;
    
    {
        EString __sequenceString ;
        if ( val.TreeArity() >= 1 ) 
            val = val [1];
        if ( !strcmp(Value(val), "name") ) {
            PutSonNext  __putSonNext(&val, true);
            __valString = "";
            EncodeIA5String(__valString, val);
            __sequenceString += __valString ;
        } else {
            val = PTREE(0);
        }
        if ( !strcmp(Value(val), "pco") ) {
            PutSonNext  __putSonNext(&val, true);
            __valString = "";
            EncodeIA5String(__valString, val);
            __sequenceString += __valString ;
        } else {
            val = PTREE(0);
        }
        if ( !strcmp(Value(val), "sender") ) {
            PutSonNext  __putSonNext(&val, true);
            __valString = "";
            EncodeIA5String(__valString, val);
            __sequenceString += __valString ;
        } else {
        }
        if ( !strcmp(Value(val), "content") ) {
            PutSonNext  __putSonNext(&val, true);
            __valString = "";
            EncodeOctetString(__valString, val);
            __sequenceString += __valString ;
        } else {
            val = PTREE(0);
        }
        if ( !strcmp(Value(val), "time") ) {
            PutSonNext  __putSonNext(&val, true);
            __valString = "";
            {
                ENCODE_INT  __val = CONVERT_TO_INT(Value(val));
                if ( NumberTree(val) == asn::UN_MINUS ) {
                    __val = -1 * __val ;
                }
                EncodeInteger(__valString, __val);
            }
            PutTag(__valString, "\200", false);
            __sequenceString += __valString ;
        } else {
        }
        if ( !strcmp(Value(val), "utime") ) {
            PutSonNext  __putSonNext(&val, true);
            __valString = "";
            {
                ENCODE_INT  __val = CONVERT_TO_INT(Value(val));
                if ( NumberTree(val) == asn::UN_MINUS ) {
                    __val = -1 * __val ;
                }
                EncodeInteger(__valString, __val);
            }
            PutTag(__valString, "\201", false);
            __sequenceString += __valString ;
        } else {
        }
        if ( !strcmp(Value(val), "ctime") ) {
            PutSonNext  __putSonNext(&val, true);
            __valString = "";
            {
                ENCODE_INT  __val = CONVERT_TO_INT(Value(val));
                if ( NumberTree(val) == asn::UN_MINUS ) {
                    __val = -1 * __val ;
                }
                EncodeInteger(__valString, __val);
            }
            PutTag(__valString, "\202", false);
            __sequenceString += __valString ;
        } else {
        }
        if ( !strcmp(Value(val), "cutime") ) {
            PutSonNext  __putSonNext(&val, true);
            __valString = "";
            {
                ENCODE_INT  __val = CONVERT_TO_INT(Value(val));
                if ( NumberTree(val) == asn::UN_MINUS ) {
                    __val = -1 * __val ;
                }
                EncodeInteger(__valString, __val);
            }
            PutTag(__valString, "\203", false);
            __sequenceString += __valString ;
        } else {
        }
        PutTag(__sequenceString, "\060", false);
        resString += __sequenceString ;
    }
}

PTREE Grammtoto::__Rule4 ( EString &val, CoordString &coord, bool checkTag )
{
    int         codedLength = coord.length ;
    int         codedPos = coord.pos ;
    PTREE       __resCoding ;
    CoordString codedCoord(coord.pos, coord.length);
    char        __tempo ;
    CoordString embeddedCodedCoord(coord.pos, coord.length);
    
    if ( checkTag ) {
        if ( (__tempo = (char)((val [coord.pos])&~0x20 & 0xff))
                && __tempo == '\020' ) {
            if ( !TakeTagged(val, 1, coord, codedCoord) ) 
                return PTREE(0);
        } else 
            return PTREE(0);
    }
    checkTag = true ;
    
    bool    __analyze = false ;
    PTREE   __listSequence ;
    PTREE   __listSequencef ;
    
    if ( codedCoord.length > 0 ) {
        if ( (__tempo = (char)((val [codedCoord.pos])&~0x20 & 0xff))
                && __tempo == '\026' ) {
            if ( !TakeTagged(val, 1, codedCoord, embeddedCodedCoord) ) 
                return PTREE(0);
            __resCoding = GetIA5String(val, embeddedCodedCoord, false);
            PTREE   __headTree = CreateNamedNode("name", __resCoding);
            __listSequencef
                = AddToList(__listSequence, __headTree, __listSequencef);
        } else {
            codedCoord.length = 0 ;
        }
    }
    
    PTREE   __retValue = PTREE(asn::SEQUENCE_VALUE, 1);
    
    __retValue.ReplaceTree(1, __listSequence);
    __resCoding = __retValue ;
    return __resCoding ;
}

void Grammtoto::__Rule4 ( EString &resString, PTREE val )
{
    EString __valString ;
    
    {
        EString __sequenceString ;
        if ( val.TreeArity() >= 1 ) 
            val = val [1];
        if ( !strcmp(Value(val), "name") ) {
            PutSonNext  __putSonNext(&val, true);
            __valString = "";
            EncodeIA5String(__valString, val);
            __sequenceString += __valString ;
        } else {
            val = PTREE(0);
        }
        PutTag(__sequenceString, "\060", false);
        resString += __sequenceString ;
    }
}

PTREE Grammtoto::__Rule5 ( EString &val, CoordString &coord, bool checkTag )
{
    int         codedLength = coord.length ;
    int         codedPos = coord.pos ;
    PTREE       __resCoding ;
    CoordString codedCoord(coord.pos, coord.length);
    char        __tempo ;
    CoordString embeddedCodedCoord(coord.pos, coord.length);
    
    if ( checkTag ) {
        if ( (__tempo = (char)((val [coord.pos])&~0x20 & 0xff))
                && __tempo == '\020' ) {
            if ( !TakeTagged(val, 1, coord, codedCoord) ) 
                return PTREE(0);
        } else 
            return PTREE(0);
    }
    checkTag = true ;
    
    bool    __analyze = false ;
    PTREE   __listSequence ;
    PTREE   __listSequencef ;
    
    if ( codedCoord.length > 0 ) {
        if ( (__tempo = (char)((val [codedCoord.pos])&~0x20 & 0xff))
                && __tempo == '\026' ) {
            if ( !TakeTagged(val, 1, codedCoord, embeddedCodedCoord) ) 
                return PTREE(0);
            __resCoding = GetIA5String(val, embeddedCodedCoord, false);
            PTREE   __headTree = CreateNamedNode("name", __resCoding);
            __listSequencef
                = AddToList(__listSequence, __headTree, __listSequencef);
        } else {
            codedCoord.length = 0 ;
        }
    }
    
    PTREE   __retValue = PTREE(asn::SEQUENCE_VALUE, 1);
    
    __retValue.ReplaceTree(1, __listSequence);
    __resCoding = __retValue ;
    return __resCoding ;
}

void Grammtoto::__Rule5 ( EString &resString, PTREE val )
{
    EString __valString ;
    
    {
        EString __sequenceString ;
        if ( val.TreeArity() >= 1 ) 
            val = val [1];
        if ( !strcmp(Value(val), "name") ) {
            PutSonNext  __putSonNext(&val, true);
            __valString = "";
            EncodeIA5String(__valString, val);
            __sequenceString += __valString ;
        } else {
            val = PTREE(0);
        }
        PutTag(__sequenceString, "\060", false);
        resString += __sequenceString ;
    }
}

PTREE Grammtoto::__Rule6 ( EString &val, CoordString &coord, bool checkTag )
{
    int         codedLength = coord.length ;
    int         codedPos = coord.pos ;
    PTREE       __resCoding ;
    CoordString codedCoord(coord.pos, coord.length);
    char        __tempo ;
    CoordString embeddedCodedCoord(coord.pos, coord.length);
    
    if ( checkTag ) {
        if ( (__tempo = (char)((val [coord.pos])&~0x20 & 0xff))
                && __tempo == '\020' ) {
            if ( !TakeTagged(val, 1, coord, codedCoord) ) 
                return PTREE(0);
        } else 
            return PTREE(0);
    }
    checkTag = true ;
    
    bool    __analyze = false ;
    PTREE   __listSequence ;
    PTREE   __listSequencef ;
    
    if ( codedCoord.length > 0 ) {
        if ( (__tempo = (char)((val [codedCoord.pos])&~0x20 & 0xff))
                && __tempo == '\026' ) {
            if ( !TakeTagged(val, 1, codedCoord, embeddedCodedCoord) ) 
                return PTREE(0);
            __resCoding = GetIA5String(val, embeddedCodedCoord, false);
            PTREE   __headTree = CreateNamedNode("name", __resCoding);
            __listSequencef
                = AddToList(__listSequence, __headTree, __listSequencef);
        } else {
            codedCoord.length = 0 ;
        }
    }
    if ( codedCoord.length > 0 ) {
        if ( (__tempo = (char)((val [codedCoord.pos])&~0x20 & 0xff))
                && __tempo == '\026' ) {
            if ( !TakeTagged(val, 1, codedCoord, embeddedCodedCoord) ) 
                return PTREE(0);
            __resCoding = GetIA5String(val, embeddedCodedCoord, false);
            PTREE   __headTree = CreateNamedNode("pco", __resCoding);
            __listSequencef
                = AddToList(__listSequence, __headTree, __listSequencef);
        } else {
            codedCoord.length = 0 ;
        }
    }
    if ( codedCoord.length > 0 ) {
        if ( (__tempo = (char)((val [codedCoord.pos])&~0x20 & 0xff))
                && __tempo == '\026' ) {
            if ( !TakeTagged(val, 1, codedCoord, embeddedCodedCoord) ) 
                return PTREE(0);
            __resCoding = GetIA5String(val, embeddedCodedCoord, false);
            PTREE   __headTree = CreateNamedNode("sender", __resCoding);
            __listSequencef
                = AddToList(__listSequence, __headTree, __listSequencef);
        } else {
        }
    }
    if ( codedCoord.length > 0 ) {
        if ( (__tempo = (char)((val [codedCoord.pos])&~0x20 & 0xff))
                && __tempo == '\004' ) {
            if ( !TakeTagged(val, 1, codedCoord, embeddedCodedCoord) ) 
                return PTREE(0);
            __resCoding = GetOctetString(val, embeddedCodedCoord, false);
            PTREE   __headTree = CreateNamedNode("content", __resCoding);
            __listSequencef
                = AddToList(__listSequence, __headTree, __listSequencef);
        } else {
            codedCoord.length = 0 ;
        }
    }
    
    PTREE   __retValue = PTREE(asn::SEQUENCE_VALUE, 1);
    
    __retValue.ReplaceTree(1, __listSequence);
    __resCoding = __retValue ;
    return __resCoding ;
}

void Grammtoto::__Rule6 ( EString &resString, PTREE val )
{
    EString __valString ;
    
    {
        EString __sequenceString ;
        if ( val.TreeArity() >= 1 ) 
            val = val [1];
        if ( !strcmp(Value(val), "name") ) {
            PutSonNext  __putSonNext(&val, true);
            __valString = "";
            EncodeIA5String(__valString, val);
            __sequenceString += __valString ;
        } else {
            val = PTREE(0);
        }
        if ( !strcmp(Value(val), "pco") ) {
            PutSonNext  __putSonNext(&val, true);
            __valString = "";
            EncodeIA5String(__valString, val);
            __sequenceString += __valString ;
        } else {
            val = PTREE(0);
        }
        if ( !strcmp(Value(val), "sender") ) {
            PutSonNext  __putSonNext(&val, true);
            __valString = "";
            EncodeIA5String(__valString, val);
            __sequenceString += __valString ;
        } else {
        }
        if ( !strcmp(Value(val), "content") ) {
            PutSonNext  __putSonNext(&val, true);
            __valString = "";
            EncodeOctetString(__valString, val);
            __sequenceString += __valString ;
        } else {
            val = PTREE(0);
        }
        PutTag(__sequenceString, "\060", false);
        resString += __sequenceString ;
    }
}

PTREE Grammtoto::__Rule7 ( EString &val, CoordString &coord, bool checkTag )
{
    int         codedLength = coord.length ;
    int         codedPos = coord.pos ;
    PTREE       __resCoding ;
    CoordString codedCoord(coord.pos, coord.length);
    char        __tempo ;
    CoordString embeddedCodedCoord(coord.pos, coord.length);
    
    if ( checkTag ) {
        if ( (__tempo = (char)((val [coord.pos])&~0x20 & 0xff))
                && __tempo == '\020' ) {
            if ( !TakeTagged(val, 1, coord, codedCoord) ) 
                return PTREE(0);
        } else 
            return PTREE(0);
    }
    checkTag = true ;
    
    bool    __analyze = false ;
    PTREE   __listSequence ;
    PTREE   __listSequencef ;
    
    if ( codedCoord.length > 0 ) {
        if ( (__tempo = (char)((val [codedCoord.pos])&~0x20 & 0xff))
                && __tempo == '\026' ) {
            if ( !TakeTagged(val, 1, codedCoord, embeddedCodedCoord) ) 
                return PTREE(0);
            __resCoding = GetIA5String(val, embeddedCodedCoord, false);
            PTREE   __headTree = CreateNamedNode("name", __resCoding);
            __listSequencef
                = AddToList(__listSequence, __headTree, __listSequencef);
        } else {
            codedCoord.length = 0 ;
        }
    }
    if ( codedCoord.length > 0 ) {
        if ( (__tempo = (char)((val [codedCoord.pos])&~0x20 & 0xff))
                && __tempo == '\026' ) {
            if ( !TakeTagged(val, 1, codedCoord, embeddedCodedCoord) ) 
                return PTREE(0);
            __resCoding = GetIA5String(val, embeddedCodedCoord, false);
            PTREE   __headTree = CreateNamedNode("pco", __resCoding);
            __listSequencef
                = AddToList(__listSequence, __headTree, __listSequencef);
        } else {
            codedCoord.length = 0 ;
        }
    }
    if ( codedCoord.length > 0 ) {
        if ( (__tempo = (char)((val [codedCoord.pos])&~0x20 & 0xff))
                && __tempo == '\026' ) {
            if ( !TakeTagged(val, 1, codedCoord, embeddedCodedCoord) ) 
                return PTREE(0);
            __resCoding = GetIA5String(val, embeddedCodedCoord, false);
            PTREE   __headTree = CreateNamedNode("sender", __resCoding);
            __listSequencef
                = AddToList(__listSequence, __headTree, __listSequencef);
        } else {
        }
    }
    if ( codedCoord.length > 0 ) {
        if ( (__tempo = (char)((val [codedCoord.pos])&~0x20 & 0xff))
                && __tempo == '\004' ) {
            if ( !TakeTagged(val, 1, codedCoord, embeddedCodedCoord) ) 
                return PTREE(0);
            __resCoding = GetOctetString(val, embeddedCodedCoord, false);
            PTREE   __headTree = CreateNamedNode("content", __resCoding);
            __listSequencef
                = AddToList(__listSequence, __headTree, __listSequencef);
        } else {
            codedCoord.length = 0 ;
        }
    }
    if ( codedCoord.length > 0 ) {
        if ( (__tempo = (char)((val [codedCoord.pos])&~0x20 & 0xff))
                && __tempo == '\200' ) {
            if ( !TakeTagged(val, 1, codedCoord, embeddedCodedCoord) ) 
                return PTREE(0);
            checkTag = true ;
            if ( true ) {
                int __startPos ;
                __startPos = embeddedCodedCoord.length ;
                __resCoding = GetInteger(val, embeddedCodedCoord, checkTag);
                if ( checkTag ) {
                    __startPos = __startPos - embeddedCodedCoord.length ;
                    codedCoord.pos += __startPos ;
                    codedCoord.length -= __startPos ;
                }
            } else 
                ;
            PTREE   __headTree = CreateNamedNode("time", __resCoding);
            __listSequencef
                = AddToList(__listSequence, __headTree, __listSequencef);
        } else {
        }
    }
    if ( codedCoord.length > 0 ) {
        if ( (__tempo = (char)((val [codedCoord.pos])&~0x20 & 0xff))
                && __tempo == '\201' ) {
            if ( !TakeTagged(val, 1, codedCoord, embeddedCodedCoord) ) 
                return PTREE(0);
            checkTag = true ;
            if ( true ) {
                int __startPos ;
                __startPos = embeddedCodedCoord.length ;
                __resCoding = GetInteger(val, embeddedCodedCoord, checkTag);
                if ( checkTag ) {
                    __startPos = __startPos - embeddedCodedCoord.length ;
                    codedCoord.pos += __startPos ;
                    codedCoord.length -= __startPos ;
                }
            } else 
                ;
            PTREE   __headTree = CreateNamedNode("utime", __resCoding);
            __listSequencef
                = AddToList(__listSequence, __headTree, __listSequencef);
        } else {
        }
    }
    
    PTREE   __retValue = PTREE(asn::SEQUENCE_VALUE, 1);
    
    __retValue.ReplaceTree(1, __listSequence);
    __resCoding = __retValue ;
    return __resCoding ;
}

void Grammtoto::__Rule7 ( EString &resString, PTREE val )
{
    EString __valString ;
    
    {
        EString __sequenceString ;
        if ( val.TreeArity() >= 1 ) 
            val = val [1];
        if ( !strcmp(Value(val), "name") ) {
            PutSonNext  __putSonNext(&val, true);
            __valString = "";
            EncodeIA5String(__valString, val);
            __sequenceString += __valString ;
        } else {
            val = PTREE(0);
        }
        if ( !strcmp(Value(val), "pco") ) {
            PutSonNext  __putSonNext(&val, true);
            __valString = "";
            EncodeIA5String(__valString, val);
            __sequenceString += __valString ;
        } else {
            val = PTREE(0);
        }
        if ( !strcmp(Value(val), "sender") ) {
            PutSonNext  __putSonNext(&val, true);
            __valString = "";
            EncodeIA5String(__valString, val);
            __sequenceString += __valString ;
        } else {
        }
        if ( !strcmp(Value(val), "content") ) {
            PutSonNext  __putSonNext(&val, true);
            __valString = "";
            EncodeOctetString(__valString, val);
            __sequenceString += __valString ;
        } else {
            val = PTREE(0);
        }
        if ( !strcmp(Value(val), "time") ) {
            PutSonNext  __putSonNext(&val, true);
            __valString = "";
            {
                ENCODE_INT  __val = CONVERT_TO_INT(Value(val));
                if ( NumberTree(val) == asn::UN_MINUS ) {
                    __val = -1 * __val ;
                }
                EncodeInteger(__valString, __val);
            }
            PutTag(__valString, "\200", false);
            __sequenceString += __valString ;
        } else {
        }
        if ( !strcmp(Value(val), "utime") ) {
            PutSonNext  __putSonNext(&val, true);
            __valString = "";
            {
                ENCODE_INT  __val = CONVERT_TO_INT(Value(val));
                if ( NumberTree(val) == asn::UN_MINUS ) {
                    __val = -1 * __val ;
                }
                EncodeInteger(__valString, __val);
            }
            PutTag(__valString, "\201", false);
            __sequenceString += __valString ;
        } else {
        }
        PutTag(__sequenceString, "\060", false);
        resString += __sequenceString ;
    }
}

PTREE Grammtoto::__Rule8 ( EString &val, CoordString &coord, bool checkTag )
{
    int         codedLength = coord.length ;
    int         codedPos = coord.pos ;
    PTREE       __resCoding ;
    CoordString codedCoord(coord.pos, coord.length);
    char        __tempo ;
    CoordString embeddedCodedCoord(coord.pos, coord.length);
    
    if ( checkTag ) {
        if ( (__tempo = (char)((val [coord.pos])&~0x20 & 0xff))
                && __tempo == '\020' ) {
            if ( !TakeTagged(val, 1, coord, codedCoord) ) 
                return PTREE(0);
        } else 
            return PTREE(0);
    }
    checkTag = true ;
    
    bool    __analyze = false ;
    PTREE   __listSequence ;
    PTREE   __listSequencef ;
    
    if ( codedCoord.length > 0 ) {
        if ( (__tempo = (char)((val [codedCoord.pos])&~0x20 & 0xff))
                && __tempo == '\026' ) {
            if ( !TakeTagged(val, 1, codedCoord, embeddedCodedCoord) ) 
                return PTREE(0);
            __resCoding = GetIA5String(val, embeddedCodedCoord, false);
            PTREE   __headTree = CreateNamedNode("name", __resCoding);
            __listSequencef
                = AddToList(__listSequence, __headTree, __listSequencef);
        } else {
            codedCoord.length = 0 ;
        }
    }
    if ( codedCoord.length > 0 ) {
        if ( (__tempo = (char)((val [codedCoord.pos])&~0x20 & 0xff))
                && __tempo == '\026' ) {
            if ( !TakeTagged(val, 1, codedCoord, embeddedCodedCoord) ) 
                return PTREE(0);
            __resCoding = GetIA5String(val, embeddedCodedCoord, false);
            PTREE   __headTree = CreateNamedNode("pco", __resCoding);
            __listSequencef
                = AddToList(__listSequence, __headTree, __listSequencef);
        } else {
        }
    }
    
    PTREE   __retValue = PTREE(asn::SEQUENCE_VALUE, 1);
    
    __retValue.ReplaceTree(1, __listSequence);
    __resCoding = __retValue ;
    return __resCoding ;
}

void Grammtoto::__Rule8 ( EString &resString, PTREE val )
{
    EString __valString ;
    
    {
        EString __sequenceString ;
        if ( val.TreeArity() >= 1 ) 
            val = val [1];
        if ( !strcmp(Value(val), "name") ) {
            PutSonNext  __putSonNext(&val, true);
            __valString = "";
            EncodeIA5String(__valString, val);
            __sequenceString += __valString ;
        } else {
            val = PTREE(0);
        }
        if ( !strcmp(Value(val), "pco") ) {
            PutSonNext  __putSonNext(&val, true);
            __valString = "";
            EncodeIA5String(__valString, val);
            __sequenceString += __valString ;
        } else {
        }
        PutTag(__sequenceString, "\060", false);
        resString += __sequenceString ;
    }
}

PTREE Grammtoto::__Rule9 ( EString &val, CoordString &coord, bool checkTag )
{
    int         codedLength = coord.length ;
    int         codedPos = coord.pos ;
    PTREE       __resCoding ;
    CoordString codedCoord(coord.pos, coord.length);
    char        __tempo ;
    CoordString embeddedCodedCoord(coord.pos, coord.length);
    
    if ( checkTag ) {
        if ( (__tempo = (char)((val [coord.pos])&~0x20 & 0xff))
                && __tempo == '\020' ) {
            if ( !TakeTagged(val, 1, coord, codedCoord) ) 
                return PTREE(0);
        } else 
            return PTREE(0);
    }
    checkTag = true ;
    
    bool    __analyze = false ;
    PTREE   __listSequence ;
    PTREE   __listSequencef ;
    
    if ( codedCoord.length > 0 ) {
        if ( (__tempo = (char)((val [codedCoord.pos])&~0x20 & 0xff))
                && __tempo == '\026' ) {
            if ( !TakeTagged(val, 1, codedCoord, embeddedCodedCoord) ) 
                return PTREE(0);
            __resCoding = GetIA5String(val, embeddedCodedCoord, false);
            PTREE   __headTree = CreateNamedNode("name", __resCoding);
            __listSequencef
                = AddToList(__listSequence, __headTree, __listSequencef);
        } else {
            codedCoord.length = 0 ;
        }
    }
    if ( codedCoord.length > 0 ) {
        if ( (__tempo = (char)((val [codedCoord.pos])&~0x20 & 0xff))
                && __tempo == '\026' ) {
            if ( !TakeTagged(val, 1, codedCoord, embeddedCodedCoord) ) 
                return PTREE(0);
            __resCoding = GetIA5String(val, embeddedCodedCoord, false);
            PTREE   __headTree = CreateNamedNode("pco", __resCoding);
            __listSequencef
                = AddToList(__listSequence, __headTree, __listSequencef);
        } else {
            codedCoord.length = 0 ;
        }
    }
    if ( codedCoord.length > 0 ) {
        if ( (__tempo = (char)((val [codedCoord.pos])&~0x20 & 0xff))
                && __tempo == '\002' ) {
            if ( !TakeTagged(val, 1, codedCoord, embeddedCodedCoord) ) 
                return PTREE(0);
            __resCoding = GetInteger(val, embeddedCodedCoord, false);
            PTREE   __headTree = CreateNamedNode("number", __resCoding);
            __listSequencef
                = AddToList(__listSequence, __headTree, __listSequencef);
        } else {
        }
    }
    
    PTREE   __retValue = PTREE(asn::SEQUENCE_VALUE, 1);
    
    __retValue.ReplaceTree(1, __listSequence);
    __resCoding = __retValue ;
    return __resCoding ;
}

void Grammtoto::__Rule9 ( EString &resString, PTREE val )
{
    EString __valString ;
    
    {
        EString __sequenceString ;
        if ( val.TreeArity() >= 1 ) 
            val = val [1];
        if ( !strcmp(Value(val), "name") ) {
            PutSonNext  __putSonNext(&val, true);
            __valString = "";
            EncodeIA5String(__valString, val);
            __sequenceString += __valString ;
        } else {
            val = PTREE(0);
        }
        if ( !strcmp(Value(val), "pco") ) {
            PutSonNext  __putSonNext(&val, true);
            __valString = "";
            EncodeIA5String(__valString, val);
            __sequenceString += __valString ;
        } else {
            val = PTREE(0);
        }
        if ( !strcmp(Value(val), "number") ) {
            PutSonNext  __putSonNext(&val, true);
            __valString = "";
            {
                ENCODE_INT  __val = CONVERT_TO_INT(Value(val));
                if ( NumberTree(val) == asn::UN_MINUS ) {
                    __val = -1 * __val ;
                }
                EncodeInteger(__valString, __val);
            }
            __sequenceString += __valString ;
        } else {
        }
        PutTag(__sequenceString, "\060", false);
        resString += __sequenceString ;
    }
}

PTREE Grammtoto::__Rule10 ( EString &val, CoordString &coord, bool checkTag )
{
    int         codedLength = coord.length ;
    int         codedPos = coord.pos ;
    PTREE       __resCoding ;
    CoordString codedCoord(coord.pos, coord.length);
    char        __tempo ;
    CoordString embeddedCodedCoord(coord.pos, coord.length);
    
    if ( checkTag ) {
        if ( (__tempo = (char)((val [coord.pos])&~0x20 & 0xff))
                && __tempo == '\020' ) {
            if ( !TakeTagged(val, 1, coord, codedCoord) ) 
                return PTREE(0);
        } else 
            return PTREE(0);
    }
    checkTag = true ;
    
    bool    __analyze = false ;
    PTREE   __listSequence ;
    PTREE   __listSequencef ;
    
    if ( codedCoord.length > 0 ) {
        if ( (__tempo = (char)((val [codedCoord.pos])&~0x20 & 0xff))
                && __tempo == '\026' ) {
            if ( !TakeTagged(val, 1, codedCoord, embeddedCodedCoord) ) 
                return PTREE(0);
            __resCoding = GetIA5String(val, embeddedCodedCoord, false);
            PTREE   __headTree = CreateNamedNode("name", __resCoding);
            __listSequencef
                = AddToList(__listSequence, __headTree, __listSequencef);
        } else {
        }
    }
    if ( codedCoord.length > 0 ) {
        if ( true ) {
            checkTag = true ;
            __resCoding = __Rule12(val, codedCoord, checkTag);
            PTREE   __headTree
                = CreateNamedNode("enumeration", __resCoding);
            __listSequencef
                = AddToList(__listSequence, __headTree, __listSequencef);
        } else {
        }
    }
    
    PTREE   __retValue = PTREE(asn::SEQUENCE_VALUE, 1);
    
    __retValue.ReplaceTree(1, __listSequence);
    __resCoding = __retValue ;
    return __resCoding ;
}

void Grammtoto::__Rule10 ( EString &resString, PTREE val )
{
    EString __valString ;
    
    {
        EString __sequenceString ;
        if ( val.TreeArity() >= 1 ) 
            val = val [1];
        if ( !strcmp(Value(val), "name") ) {
            PutSonNext  __putSonNext(&val, true);
            __valString = "";
            EncodeIA5String(__valString, val);
            __sequenceString += __valString ;
        } else {
        }
        if ( !strcmp(Value(val), "enumeration") ) {
            PutSonNext  __putSonNext(&val, true);
            __valString = "";
            __Rule12(__valString, val);
            __sequenceString += __valString ;
        } else {
        }
        PutTag(__sequenceString, "\060", false);
        resString += __sequenceString ;
    }
}

PTREE Grammtoto::__Rule11 ( EString &val, CoordString &coord, bool checkTag )
{
    int         codedLength = coord.length ;
    int         codedPos = coord.pos ;
    PTREE       __resCoding ;
    CoordString codedCoord(coord.pos, coord.length);
    char        __tempo ;
    
    if ( 1 ) {
        int __startPos ;
        __startPos = codedCoord.length ;
        __resCoding = GetRealString(val, codedCoord, checkTag);
        if ( checkTag ) {
            __startPos = __startPos - codedCoord.length ;
            coord.pos += __startPos ;
            coord.length -= __startPos ;
        }
    } else 
        ;
    return __resCoding ;
}

void Grammtoto::__Rule11 ( EString &resString, PTREE val )
{
    EString __valString ;
    
    EncodeRealString(__valString, val);
}

PTREE Grammtoto::__Rule12 ( EString &val, CoordString &coord, bool checkTag )
{
    int         codedLength = coord.length ;
    int         codedPos = coord.pos ;
    PTREE       __resCoding ;
    CoordString codedCoord(coord.pos, coord.length);
    char        __tempo ;
    
    if ( checkTag ) {
        if ( (__tempo = (char)((val [coord.pos])&~0x20 & 0xff))
                && __tempo == '\020' ) {
            if ( !TakeTagged(val, 1, coord, codedCoord) ) 
                return PTREE(0);
        } else 
            return PTREE(0);
    }
    checkTag = true ;
    
    PTREE   __listSequence ;
    PTREE   __listSequencef ;
    
    while ( codedCoord.length > 0 ) {
        __resCoding = __Rule13(val, codedCoord, checkTag);
        if ( __resCoding == PTREE(0) ) 
            return __resCoding ;
        __listSequencef
            = AddToList(__listSequence, __resCoding, __listSequencef);
    }
    
    PTREE   __retValue = PTREE(asn::SEQUENCE_VALUE, 1);
    
    __retValue.ReplaceTree(1, __listSequence);
    __resCoding = __retValue ;
    return __resCoding ;
}

void Grammtoto::__Rule12 ( EString &resString, PTREE val )
{
    EString __valString ;
    
    {
        EString __sequenceString ;
        if ( val.TreeArity() >= 1 ) 
            val = val [1];
        while ( val != PTREE(0) ) {
            __valString = "";
            PutSonNext  __putSonNext(&val, false);
            {
                __Rule13(__valString, val);
            }
            __sequenceString += __valString ;
        }
        PutTag(__sequenceString, "\060", false);
        resString += __sequenceString ;
    }
}

PTREE Grammtoto::__Rule13 ( EString &val, CoordString &coord, bool checkTag )
{
    int         codedLength = coord.length ;
    int         codedPos = coord.pos ;
    PTREE       __resCoding ;
    CoordString codedCoord(coord.pos, coord.length);
    char        __tempo ;
    CoordString embeddedCodedCoord(coord.pos, coord.length);
    
    if ( checkTag ) {
        if ( (__tempo = (char)((val [coord.pos])&~0x20 & 0xff))
                && __tempo == '\020' ) {
            if ( !TakeTagged(val, 1, coord, codedCoord) ) 
                return PTREE(0);
        } else 
            return PTREE(0);
    }
    checkTag = true ;
    
    bool    __analyze = false ;
    PTREE   __listSequence ;
    PTREE   __listSequencef ;
    
    if ( codedCoord.length > 0 ) {
        if ( (__tempo = (char)((val [codedCoord.pos])&~0x20 & 0xff))
                && __tempo == '\026' ) {
            if ( !TakeTagged(val, 1, codedCoord, embeddedCodedCoord) ) 
                return PTREE(0);
            __resCoding = GetIA5String(val, embeddedCodedCoord, false);
            PTREE   __headTree = CreateNamedNode("bus", __resCoding);
            __listSequencef
                = AddToList(__listSequence, __headTree, __listSequencef);
        } else {
            codedCoord.length = 0 ;
        }
    }
    if ( codedCoord.length > 0 ) {
        if ( true ) {
            checkTag = true ;
            __resCoding = __Rule14(val, codedCoord, checkTag);
            PTREE   __headTree = CreateNamedNode("connected", __resCoding);
            __listSequencef
                = AddToList(__listSequence, __headTree, __listSequencef);
        } else {
            codedCoord.length = 0 ;
        }
    }
    
    PTREE   __retValue = PTREE(asn::SEQUENCE_VALUE, 1);
    
    __retValue.ReplaceTree(1, __listSequence);
    __resCoding = __retValue ;
    return __resCoding ;
}

void Grammtoto::__Rule13 ( EString &resString, PTREE val )
{
    EString __valString ;
    
    {
        EString __sequenceString ;
        if ( val.TreeArity() >= 1 ) 
            val = val [1];
        if ( !strcmp(Value(val), "bus") ) {
            PutSonNext  __putSonNext(&val, true);
            __valString = "";
            EncodeIA5String(__valString, val);
            __sequenceString += __valString ;
        } else {
            val = PTREE(0);
        }
        if ( !strcmp(Value(val), "connected") ) {
            PutSonNext  __putSonNext(&val, true);
            __valString = "";
            __Rule14(__valString, val);
            __sequenceString += __valString ;
        } else {
            val = PTREE(0);
        }
        PutTag(__sequenceString, "\060", false);
        resString += __sequenceString ;
    }
}

PTREE Grammtoto::__Rule14 ( EString &val, CoordString &coord, bool checkTag )
{
    int         codedLength = coord.length ;
    int         codedPos = coord.pos ;
    PTREE       __resCoding ;
    CoordString codedCoord(coord.pos, coord.length);
    char        __tempo ;
    
    if ( checkTag ) {
        if ( (__tempo = (char)((val [coord.pos])&~0x20 & 0xff))
                && __tempo == '\020' ) {
            if ( !TakeTagged(val, 1, coord, codedCoord) ) 
                return PTREE(0);
        } else 
            return PTREE(0);
    }
    checkTag = true ;
    
    PTREE   __listSequence ;
    PTREE   __listSequencef ;
    
    while ( codedCoord.length > 0 ) {
        if ( 1 ) {
            int __startPos ;
            __startPos = codedCoord.length ;
            __resCoding = GetIA5String(val, codedCoord, checkTag);
            if ( checkTag ) {
                __startPos = __startPos - codedCoord.length ;
                coord.pos += __startPos ;
                coord.length -= __startPos ;
            }
        } else 
            ;
        if ( __resCoding == PTREE(0) ) 
            return __resCoding ;
        __listSequencef
            = AddToList(__listSequence, __resCoding, __listSequencef);
    }
    
    PTREE   __retValue = PTREE(asn::SEQUENCE_VALUE, 1);
    
    __retValue.ReplaceTree(1, __listSequence);
    __resCoding = __retValue ;
    return __resCoding ;
}

void Grammtoto::__Rule14 ( EString &resString, PTREE val )
{
    EString __valString ;
    
    {
        EString __sequenceString ;
        if ( val.TreeArity() >= 1 ) 
            val = val [1];
        while ( val != PTREE(0) ) {
            __valString = "";
            PutSonNext  __putSonNext(&val, false);
            {
                EncodeIA5String(__valString, val);
            }
            __sequenceString += __valString ;
        }
        PutTag(__sequenceString, "\060", false);
        resString += __sequenceString ;
    }
}
